﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=11.5
@EndOfDesignText@
Sub Class_Globals
	Private Root As B4XView 'ignore
	Private xui As XUI 'ignore
	Private db As database
	Private clv3 As CustomListView
	Private sbtn3 As SwiftButton
	Private dragger As CLVDragger
	' cat_dialog
	Private ftf1 As B4XFloatTextField
	Private ftf2 As B4XFloatTextField
	Private db As database
	Private catdialog As B4XDialog
	Private pnlnav1 As Panel
	Private pnlnav2 As Panel
	Private pnlnav3 As Panel
	Private pnlnav4 As Panel
	Private pnlnav5 As Panel
	Private cbxaccounts As B4XComboBox
	Private lblaccountname As Label
End Sub

Public Sub Initialize As Object
	Return Me
End Sub

Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	'load the layout to Root
	Root.LoadLayout("category_layout")
	B4XPages.SetTitle(Me,"Budget with accounts - category")
	db.Initialize("budget_with_accounts","budget_db",True,False)
	dragger.Initialize(clv3)
	dragger.AddDragButtons
	catdialog.Initialize(Root)
	catdialog.PutAtTop = True
	catdialog.BackgroundColor = Colors.LightGray
	catdialog.BodyTextColor = Colors.Blue
End Sub

private Sub B4XPage_Appear
	set_colors(pnlnav4)
	If B4XPages.MainPage.selected_account = 0 Then
		Return
	End If
	If db.get_num_rows("accounts") > 0 Then
		Private rs1  As ResultSet = db.find_record("accounts",B4XPages.MainPage.selected_account)
		If rs1.NextRow Then
			lblaccountname.Text = rs1.GetString("name") & " " & rs1.GetString("accountnumber")
			lblaccountname.Tag = rs1.GetString("rowid")
		End If
	End If
	'fill_cbxaccounts
	fill_clv3
End Sub

Private Sub B4XPage_Disappear
	If clv3.Size > 0 Then
		For i = 0 To clv3.Size - 1
			Private rs1  As ResultSet = db.find_record("category",clv3.GetValue(i))
			rs1.NextRow			
			db.change_record("category", Array As String(rs1.GetString("name"),rs1.GetString("reference"),lblaccountname.Tag,i),clv3.GetValue(i))
		Next
	End If
End Sub

Private Sub set_panel_colors(pnl As Panel,clr1 As Int,clr2 As Int)
	Dim lbl As Label = pnl.GetView(0).As(Label)
	lbl.TextColor = clr1
	Dim lbl As Label = pnl.GetView(1).As(Label)
	lbl.TextColor = clr1
	If pnl.NumberOfViews > 2 Then
		Dim lbl As Label = pnl.GetView(2).As(Label)
		lbl.Color = clr2
	End If
End Sub
Private Sub set_colors(pnl As Panel)
	set_panel_colors(pnlnav1,Colors.Black,Colors.Black)
	set_panel_colors(pnlnav2,Colors.Black,Colors.Black)
	set_panel_colors(pnlnav3,Colors.Black,Colors.Black)
	set_panel_colors(pnlnav4,Colors.Black,Colors.Black)
	set_panel_colors(pnlnav5,Colors.Black,Colors.Black)
	set_panel_colors(pnl,Colors.Blue,Colors.Blue)
End Sub

Private Sub fill_cbxaccounts
	Private lst As List
	lst.Initialize
	For i = 0 To B4XPages.MainPage.clvdash.Size -1
		Dim strname As String = B4XPages.MainPage.clvdash.GetRawListItem(i).Value
		lst.Add(strname)
	Next
	cbxaccounts.SetItems(lst)
	cbxaccounts.SelectedIndex = B4XPages.MainPage.selected_account
End Sub

Sub clv3_ItemClick (Index As Int, Value As Object)
	show_change_dialog("category",Value, "Category",Colors.ARGB(100,255,255,135),Index)
	dragger.Initialize(clv3)
	dragger.AddDragButtons
End Sub

Sub sbtn3_Click
	show_add_dialog("category", "Category",Colors.ARGB(100,255,255,135))
	dragger.Initialize(clv3)
	dragger.AddDragButtons
End Sub

Private Sub fill_clv3
	clv3.Clear
	Private sql As String = "SELECT rowid, name, reference, account_id FROM category WHERE account_id = ?"
	sql = sql & " ORDER BY sequence"
	Private id() As String = Array As String(lblaccountname.tag)
	Private rs1  As ResultSet = db.select_query_prepared(sql,id)
	Do While rs1.NextRow
		clv3.AddTextItem(rs1.GetString("name") & " " & rs1.GetString("reference"),rs1.GetString("rowid"))
	Loop
	If clv3.Size > 0 Then
		dragger.Initialize(clv3)
		dragger.AddDragButtons
	End If
End Sub

Private Sub show_add_dialog(tablename As String, title As String,title_color As Int)
	Dim fldlst As List = db.get_fieldnames(tablename)
	Dim pnl1 As Panel = setup_dialog("category_dialog_layout"," Add " & title,title_color)
	Dim rsub1 As ResumableSub =  catdialog.ShowCustom(pnl1, "OK", "", "CANCEL")
	ftf1.HintText = fldlst.Get(1)
	ftf1.Update
	ftf2.HintText = fldlst.Get(2)
	ftf2.update
	Wait For (rsub1) Complete (Result As Int)
	If Result = xui.dialogResponse_Positive Then
		If ftf1.Text <> "" Then
			db.add_record(tablename, Array As String(ftf1.Text,ftf2.Text,lblaccountname.Tag,0))
			reset_list(tablename)
		End If
	End If
End Sub
Private Sub show_change_dialog(tablename As String,rowid As Int, title As String, title_color As Int,seq As Int)
	Dim fldlst As List = db.get_fieldnames(tablename)
	Dim pnl1 As Panel = setup_dialog("category_dialog_layout"," Edit/Delete " & title, title_color)
	Dim rsub1 As ResumableSub =  catdialog.ShowCustom(pnl1, "SAVE", "DELETE", "CANCEL")
	Private rs1  As ResultSet = db.find_record(tablename,rowid)
	If rs1.NextRow Then
		ftf1.Text = rs1.GetString(fldlst.Get(1))
		ftf2.Text = rs1.GetString(fldlst.Get(2))
	End If
	'ftf1.Text = rowid
	ftf1.HintText = fldlst.Get(1)
	ftf1.Update
	ftf2.HintText = fldlst.Get(2)
	ftf2.update
	Wait For (rsub1) Complete (Result As Int)
	If Result = xui.dialogResponse_Positive Then
		If ftf1.Text <> "" Then
			db.change_record(tablename, Array As String(ftf1.Text,ftf2.Text,lblaccountname.Tag,seq),rowid)
			reset_list(tablename)
		End If
	else if Result = xui.dialogResponse_Negative Then
		db.remove_record(tablename,rowid)
		reset_list(tablename)
	End If
End Sub
private Sub setup_dialog(strlayout As String,lbltext As String,lblcolor As Int) As Panel
	Dim pnl As B4XView = xui.CreatePanel("")
	pnl.SetLayoutAnimated(0, 0, 0, 340dip, 200dip)
	pnl.LoadLayout(strlayout)
	Dim lbl As Label
	lbl.Initialize("")
	lbl.Text = lbltext
	lbl.TextSize = 18
	lbl.TextColor = Colors.Black
	lbl.Color = lblcolor
	pnl.AddView(lbl,0,0dip,340dip,30dip)
	Return pnl
End Sub

Private Sub reset_list(tablename As String)
	fill_clv3
End Sub

Private Sub pnlNavigation_Click
	B4XPages.MainPage.pnlNavigation_Click
End Sub
