﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=11.5
@EndOfDesignText@
Sub Class_Globals
	Private Root As B4XView 'ignore
	Private xui As XUI 'ignore
	Private db As database
	Private btnend As Button
	Private btnreset As Button
	Private btnsave As Button
	Private btnstart As Button
	Private ftfcurrency As B4XFloatTextField
	Private ftfend As B4XFloatTextField
	Private ftfstart As B4XFloatTextField
	Private ftfstartbalance As B4XFloatTextField
	' calendar dialog
	Private cal As calendar
	Private pnl1 As Panel
	Private	currentticks As Long = DateTime.Now
	Public currentmonth As Int = DateTime.GetMonth(currentticks)
	Public currentyear As Int = DateTime.GetYear(currentticks)
	Public currentday As Int = DateTime.GetDayOfMonth(currentticks)
	Public lblseldate As Label
	Private caldialog As B4XDialog
	Public displayyear As Int
	Public displaymonth As Int
	Public setdate As String
	Private db As database
	Private pnlnav1 As Panel
	Private pnlnav2 As Panel
	Private pnlnav3 As Panel
	Private pnlnav4 As Panel
	Private pnlnav5 As Panel
	Private cbxaccounts As B4XComboBox
	Private lblaccountname As Label
	Private pnlnavbar As Panel
End Sub

Public Sub Initialize As Object
	Return Me
End Sub

Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	'load the layout to Root
	Root.LoadLayout("settings_layout")
	B4XPages.SetTitle(Me,"Budget with accounts - settings")
	db.Initialize("budget_with_accounts","budget_db",True,False)
	DateTime.DateFormat = "yyyy-MM-dd"
	' calendar dialog
	cal.Initialize(Me,"cal")
	caldialog.Initialize(Root)
	caldialog.PutAtTop = True
	caldialog.BackgroundColor = Colors.White
	lblseldate.Initialize("")
	pnl1.Initialize("")
	displayyear = currentyear
	displaymonth = currentmonth

End Sub

Private Sub B4XPage_appear
	set_colors(pnlnav5)
	If B4XPages.MainPage.selected_account = 0 Then
		Return
	End If
	btnreset_Click
	If db.get_num_rows("accounts") > 0 Then
		Private rs1  As ResultSet = db.find_record("accounts",B4XPages.MainPage.selected_account)
		If rs1.NextRow Then
			lblaccountname.Text = rs1.GetString("name") & " " & rs1.GetString("accountnumber")
			lblaccountname.Tag = rs1.GetString("rowid")
		End If
	End If
	'fill_cbxaccounts
	If db.get_num_rows("settings") > 0 Then
		Private sql As String = "SELECT rowid, startdate, enddate, startbalance, currency, account_id"
		sql = sql & " FROM settings WHERE account_id = ?"
		Private id() As String = Array As String(lblaccountname.tag)
		Private rs1  As ResultSet = db.select_query_prepared(sql,id)
		If rs1.NextRow Then
			ftfstart.Text = rs1.GetString("startdate")
			ftfend.Text = rs1.GetString("enddate")
			ftfstartbalance.Text = rs1.GetString("startbalance")
			ftfcurrency.Text = rs1.GetString("currency")
		End If
	Else
		btnreset_Click
	End If
End Sub

Private Sub set_panel_colors(pnl As Panel,clr1 As Int,clr2 As Int)
	Dim lbl As Label = pnl.GetView(0).As(Label)
	lbl.TextColor = clr1
	Dim lbl As Label = pnl.GetView(1).As(Label)
	lbl.TextColor = clr1
	If pnl.NumberOfViews > 2 Then
		Dim lbl As Label = pnl.GetView(2).As(Label)
		lbl.Color = clr2
	End If
End Sub
Private Sub set_colors(pnl As Panel)
	set_panel_colors(pnlnav1,Colors.Black,Colors.Black)
	set_panel_colors(pnlnav2,Colors.Black,Colors.Black)
	set_panel_colors(pnlnav3,Colors.Black,Colors.Black)
	set_panel_colors(pnlnav4,Colors.Black,Colors.Black)
	set_panel_colors(pnlnav5,Colors.Black,Colors.Black)
	set_panel_colors(pnl,Colors.Blue,Colors.Blue)
End Sub

Private Sub fill_cbxaccounts
	Private lst As List
	lst.Initialize
	For i = 0 To B4XPages.MainPage.clvdash.Size -1
		Dim strname As String = B4XPages.MainPage.clvdash.GetRawListItem(i).Value
		lst.Add(strname)
	Next
	cbxaccounts.SetItems(lst)
	cbxaccounts.SelectedIndex = B4XPages.MainPage.selected_account
End Sub
Private Sub cbxaccounts_SelectedIndexChanged (Index As Int)
	
End Sub

Sub btnsave_Click
	If ftfstart.text = "" Or ftfend.text = "" Or ftfstartbalance.text = "" Or ftfcurrency.text = "" Then
		xui.MsgboxAsync("All the fields must be filled!", "Mybudget - Settings")
	End If
	If db.get_num_rows("settings") > 0 Then
		Private sql As String = "SELECT rowid, startdate, enddate, startbalance, currency, account_id"
		sql = sql & " FROM settings WHERE account_id = ?"
		Private id() As String = Array As String(lblaccountname.tag)
		Private rs1  As ResultSet = db.select_query_prepared(sql,id)
		If rs1.NextRow Then
			Private rowid As Int = rs1.GetString("rowid")
			db.change_record("settings", Array As String(ftfstart.Text,ftfend.Text,ftfstartbalance.Text,ftfcurrency.text,lblaccountname.tag),rowid)
		Else
			db.add_record("settings", Array As String(ftfstart.Text,ftfend.Text,ftfstartbalance.Text,ftfcurrency.text,lblaccountname.tag))			
		End If
	Else
		db.add_record("settings", Array As String(ftfstart.Text,ftfend.Text,ftfstartbalance.Text,ftfcurrency.text,lblaccountname.tag))
	End If
End Sub
	
Sub btnreset_Click
	ftfstart.Text = ""
	ftfend.Text = ""
	ftfstartbalance.Text = 0
	ftfcurrency.Text = "EUR"
	'btnsave_Click
End Sub

Sub btnstart_Click
	setdate = "startdate"
	datepicker_dialog
End Sub

Sub btnend_Click
	setdate = "enddate"
	datepicker_dialog
End Sub

Sub datepicker_dialog
	lblseldate.Text = ""
	pnl1.Color = Colors.White
	pnl1.SetLayoutAnimated(0dip, 0dip, 0dip, 278dip, 368dip)
	pnl1 = cal.set_date_picker(displaymonth,displayyear)
	Dim rsub1 As ResumableSub =  caldialog.ShowCustom(pnl1, "OK", "", "CANCEL")
	Wait For (rsub1) Complete (Result As Int)
	If Result = xui.dialogResponse_Positive Then
		If setdate = "startdate" Then
			ftfstart.Text = lblseldate.Text
			'B4XPages.MainPage.strstartticks = cal.lblticks
		End If
		If setdate = "enddate" Then
			ftfend.Text = lblseldate.Text
			'B4XPages.MainPage.strendticks = cal.lblticks
		End If
	End If
	If Result = xui.dialogResponse_Negative Then
		lblseldate.Text = ""
	End If
	displayyear = currentyear
	displaymonth = currentmonth
End Sub

Public Sub cal_dayclick
	Dim dayticks As Long = cal.lblticks
	Log(dayticks)	' date ticks value
	DateTime.DateFormat = "yyyy-MM-dd"
	lblseldate.Text = DateTime.Date(dayticks)
End Sub
Sub cal_btnprevclick
	displaymonth = displaymonth - 1
	If displaymonth < 1 Then
		displaymonth = 12
		displayyear = displayyear - 1
	End If
	datepicker_dialog
End Sub
Sub cal_btnnextclick
	displaymonth = displaymonth + 1
	If displaymonth > 12 Then
		displaymonth = 1
		displayyear = displayyear + 1
	End If
	datepicker_dialog
End Sub
Sub cal_btntodayclick
	displaymonth = currentmonth
	displayyear = currentyear
	datepicker_dialog
End Sub

Private Sub pnlNavigation_Click
	B4XPages.MainPage.pnlNavigation_Click
End Sub

